#include "at32f403a_407.h"
#include "modbus_ao_params.h"
#include "settings_api.h"
#include "modbus_params.h"
#include "analog_output.h"


#if defined (MAO_4)


extern mb_param_t mb_param[];


//
uint16_t mb_init_ao_params(uint16_t i)
{
    uint16_t index = i;
    //uint16_t addr = 0;  
  
    // Статус выходов (вкл./выкл.)
    mb_param[index].reg = 0x0400;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&settings.ao_state_bits;
	mb_param[index].set = mb_set_ao_state;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    // Режим работы выходов
    mb_param[index].reg = 0x0401;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&settings.ao_mode_bits;
	mb_param[index].set = mb_set_ao_mode;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    // ---------------------------------------------------------------------- //
    
    return index;
}




// -------------------------------------------------------------------------- //
//                          Установка параметров
// -------------------------------------------------------------------------- //

//
mb_delay_action_t mb_set_ao_state(void)
{
    ao_set();
    return MB_NO_ACTION;
}

//
mb_delay_action_t mb_set_ao_mode(void)
{
  
#if 0  
    ai_set_meas_mode();  
#endif    
    return MB_SAVE_SETTINGS;
}


#endif